#ifndef _MY_CRYPT_
#define _MY_CRYPT_

#include <config.h>
#include <turbo/turbo.h>

#define CRYPT_OK		0
#define CRYPT_ERROR		1
#define CRYPT_INVALID_KEYSIZE	2
#define CRYPT_INVALID_ROUNDS	3

#define AES_MAXNR 14
#define AES_BLOCK_SIZE 16

/* This should be a hidden type, but EVP requires that the size be known */
struct _aes_key_st
{
  unsigned long rd_key[4 * (AES_MAXNR + 1)];
  int rounds;
};
typedef struct _aes_key_st aes_key;

void aes_set_encrypt_key (const unsigned char *userKey, const int bits,
			  aes_key * key);
void aes_set_decrypt_key (const unsigned char *userKey, const int bits,
			  aes_key * key);

void aes_encrypt (const unsigned char *in, unsigned char *out,
		  const aes_key * key);
void aes_decrypt (const unsigned char *in, unsigned char *out,
		  const aes_key * key);

#endif
