#ifndef __H__IFACE_CRYPTO_H__
#define __H__IFACE_CRYPTO_H__

#include "config.h"

#include "crypto.h"

#define KEY_ENCRYPT	0
#define KEY_DECRYPT	1

#ifdef USE_AES
typedef aes_key crypto_key;
#else
typedef Twofish_key crypto_key;
#endif

u8 crypto_key_setup (u8 * key, u8 keylen, crypto_key * skey, u8 dir);

void crypto_ecb_decrypt (u8 * ct, u8 * pt, crypto_key * key);
void crypto_ecb_encrypt (u8 * ct, u8 * pt, crypto_key * key);

u8 crypto_cbc_decrypt (u8 * in, u8 * out, u8 nr_blocks, crypto_key * key);
u8 crypto_cbc_encrypt (u8 * in, u8 * out, u8 nr_blocks, crypto_key * key);

u8 crypto_ctr (u8 * in, u8 * out, u8 nr_blocks, u8 * ptkey, crypto_key * key,
	       u8 dir);

#endif
